/*
 * mainprog.cpp
 *
 *  Created on: Oct 2, 2008
 *      Author: bloch
 *
 *      Projects "Vehicles v1" and "Vehicles v2" illustrate the difference between composition and inheritance.
 *      In "Vehicles v1", a Car and a Canoe both contain a pointer to a Vehicle object, and methods on
 *      these classes explicitly delegate to the Vehicle object as appropriate.  (Class composition.)
 *      In "Vehicles v2", a Car and a Canoe are both subclasses of Vehicle, and methods that are already
 *      defined on Vehicle don't need to be redefined on Car or Canoe unless they do something different.
 *      (Class inheritance.)
 *      Each has its advantages: inheritance often saves you some work, but it means that EVERY method
 *      defined on Vehicles is applicable to Cars and Canoes.  If you don't want this, use either
 *      composition or private inheritance.  Private inheritance exists in C++ but not in Java.
 *
 *
 */

#include "Vehicle.h"
#include "Car.h"
#include "Engine.h"
#include "Canoe.h"

#include <iostream>
using std::cout;
using std::endl;

int main ()
{
	Vehicle bike(20, 40, "red");
	Engine subaru(4, 28);
	Car mine(80, 1500, "gold", 5, subaru);
	Canoe yours(5, 60, "silver", 13);

	cout << "Bike: speed " << bike.getSpeed()
		<< ", weight " << bike.getWeight()
		<< ", color " << bike.getColor()
		<< endl;
	cout << "My car: speed " << mine.getSpeed()
		<< ", weight " << mine.getWeight()
		<< ", color " << mine.getColor()
		<< ", " << mine.getEngine().getCylinders() << " cylinders"
		<< ", " << mine.getEngine().getMPG() << " MPG"
		<< endl;
	cout << "Your canoe: speed " << yours.getSpeed()
		<< ", weight " << yours.getWeight()
		<< ", color " << yours.getColor()
		<< ", " << yours.getLength() << " feet long"
		<< endl;


	return 0;
}
